<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice_details".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PracticeDetails".
 *
 * Columns in table "practice_details" available as properties of the model,
 * followed by relations of table "practice_details" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property integer $practice_type_id
 * @property integer $coverage_location_id
 * @property integer $coverage_state_id
 * @property integer $coverage_radius
 * @property integer $emr_name
 * @property integer $dme_service
 * @property integer $emr_id
 * @property integer $practice_size
 * @property integer $sole_proprietor_provider_id
 * @property string $twilio_number
 * @property integer $twilio_status
 * @property string $reviewhub_sharing
 * @property string $review_request_auto_daily_limit
 * @property string $score_missing_data
 * @property string $uberall_location_id
 * @property string $yext_special_offer
 * @property string $reward_email
 * @property string $email_prefix
 * @property string $review_request_auto_subject
 * @property string $review_request_email_subject
 * @property string $review_request_service_text
 * @property string $review_request_service_link
 * @property string $review_request_email_title
 * @property string $review_request_email_body
 * @property string $review_request_sms_body
 * @property string $review_request_auto_body
 * @property string $google_review_email_title
 * @property string $google_review_email_body
 * @property string $google_review_sms_body
 * @property string $date_added
 * @property string $date_updated
 * @property string $yelp_review_email_title
 * @property string $yelp_review_email_body
 * @property string $yelp_review_sms_body
 * @property string $close_status
 * @property string $geolocation_date
 * @property string $geolocation_source
 * @property string $geolocation_payload
 *
 * @property Practice $practice
 * @property Emr $emr
 * @property State $coverageState
 * @property Location $coverageLocation
 * @property PracticeType $practiceType
 * @property Provider $soleProprietorProvider
 */
abstract class BasePracticeDetails extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice_details';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PracticeDetails|PracticeDetails', $n);
    }

    public static function representingColumn()
    {
        return 'twilio_number';
    }

    public function rules()
    {
        return array(
            array('practice_id', 'required'),
            array('practice_id, practice_type_id, coverage_location_id, coverage_state_id, coverage_radius, emr_name, dme_service, emr_id,
            practice_size, sole_proprietor_provider_id, twilio_status', 'numerical', 'integerOnly' => true),
            array('twilio_number', 'length', 'max' => 10),
            array('reviewhub_sharing', 'length', 'max' => 7),
            array('review_request_auto_daily_limit', 'length', 'max' => 3),
            array('uberall_location_id', 'length', 'max' => 20),
            array('yext_special_offer', 'length', 'max' => 50),
            array(
                'reward_email, email_prefix, review_request_auto_subject, review_request_email_subject, review_request_service_text,
                review_request_service_link, review_request_email_title, google_review_email_title, yelp_review_email_title, close_status',
                'length', 'max' => 255
            ),
            array('score_missing_data, review_request_email_body, review_request_sms_body, review_request_auto_body, google_review_email_body,
            google_review_sms_body, date_added, date_updated, yelp_review_email_body, yelp_review_sms_body, close_status', 'safe'),
            array('practice_type_id, coverage_location_id, coverage_state_id, coverage_radius, emr_name, dme_service, emr_id, practice_size,
            sole_proprietor_provider_id, twilio_number, twilio_status, reviewhub_sharing, review_request_auto_daily_limit, score_missing_data,
            uberall_location_id, yext_special_offer, reward_email, email_prefix, review_request_auto_subject, review_request_email_subject,
            review_request_service_text, review_request_service_link, review_request_email_title, review_request_email_body, review_request_sms_body,
            review_request_auto_body, google_review_email_title, google_review_email_body, google_review_sms_body, date_added,
            date_updated, yelp_review_email_title, yelp_review_email_body, yelp_review_sms_body, close_status, geolocation_date, geolocation_source,
            geolocation_payload', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, practice_id, practice_type_id, coverage_location_id, coverage_state_id, coverage_radius, emr_name, dme_service, emr_id,
            practice_size, sole_proprietor_provider_id, twilio_number, twilio_status, reviewhub_sharing, review_request_auto_daily_limit,
            score_missing_data, uberall_location_id, yext_special_offer, reward_email, email_prefix, review_request_auto_subject,
            review_request_email_subject, review_request_service_text, review_request_service_link, review_request_email_title,
            review_request_email_body, review_request_sms_body, review_request_auto_body, google_review_email_title, google_review_email_body,
            google_review_sms_body, date_added, date_updated, yelp_review_email_title, yelp_review_email_body, yelp_review_sms_body,close_status,
            geolocation_date, geolocation_source, geolocation_payload',
                'safe', 'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'emr' => array(self::BELONGS_TO, 'Emr', 'emr_id'),
            'coverageState' => array(self::BELONGS_TO, 'State', 'coverage_state_id'),
            'coverageLocation' => array(self::BELONGS_TO, 'Location', 'coverage_location_id'),
            'practiceType' => array(self::BELONGS_TO, 'PracticeType', 'practice_type_id'),
            'soleProprietorProvider' => array(self::BELONGS_TO, 'Provider', 'sole_proprietor_provider_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => null,
            'practice_type_id' => null,
            'coverage_location_id' => null,
            'coverage_state_id' => null,
            'coverage_radius' => Yii::t('app', 'Coverage Radius'),
            'emr_name' => Yii::t('app', 'Emr Name'),
            'dme_service' => Yii::t('app', 'Dme Service'),
            'emr_id' => null,
            'practice_size' => Yii::t('app', 'Practice Size'),
            'sole_proprietor_provider_id' => null,
            'twilio_number' => Yii::t('app', 'Twilio Number'),
            'twilio_status' => Yii::t('app', 'Twilio Status'),
            'reviewhub_sharing' => Yii::t('app', 'Reviewhub Sharing'),
            'review_request_auto_daily_limit' => Yii::t('app', 'Review Request Auto Daily Limit'),
            'score_missing_data' => Yii::t('app', 'Score Missing Data'),
            'uberall_location_id' => Yii::t('app', 'Uberall Location'),
            'yext_special_offer' => Yii::t('app', 'Yext Special Offer'),
            'reward_email' => Yii::t('app', 'Reward Email'),
            'email_prefix' => Yii::t('app', 'Email Prefix'),
            'review_request_auto_subject' => Yii::t('app', 'Review Request Auto Subject'),
            'review_request_email_subject' => Yii::t('app', 'Review Request Email Subject'),
            'review_request_service_text' => Yii::t('app', 'Review Request Service Text'),
            'review_request_service_link' => Yii::t('app', 'Review Request Service Link'),
            'review_request_email_title' => Yii::t('app', 'Review Request Email Title'),
            'review_request_email_body' => Yii::t('app', 'Review Request Email Body'),
            'review_request_sms_body' => Yii::t('app', 'Review Request Sms Body'),
            'review_request_auto_body' => Yii::t('app', 'Review Request Auto Body'),
            'google_review_email_title' => Yii::t('app', 'Google Review Email Title'),
            'google_review_email_body' => Yii::t('app', 'Google Review Email Body'),
            'google_review_sms_body' => Yii::t('app', 'Google Review Sms Body'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'yelp_review_email_title' => Yii::t('app', 'Yelp Review Email Title'),
            'yelp_review_email_body' => Yii::t('app', 'Yelp Review Email Body'),
            'yelp_review_sms_body' => Yii::t('app', 'Yelp Review Sms Body'),
            'close_status' => Yii::t('app', 'Open/Close Status'),
            'geolocation_date' => Yii::t('app', 'Geolocation Date'),
            'geolocation_source' => Yii::t('app', 'Geolocation Source'),
            'geolocation_payload' => Yii::t('app', 'Geolocation Payload'),
            'practice' => null,
            'emr' => null,
            'coverageState' => null,
            'coverageLocation' => null,
            'practiceType' => null,
            'soleProprietorProvider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('practice_type_id', $this->practice_type_id);
        $criteria->compare('coverage_location_id', $this->coverage_location_id);
        $criteria->compare('coverage_state_id', $this->coverage_state_id);
        $criteria->compare('coverage_radius', $this->coverage_radius);
        $criteria->compare('emr_name', $this->emr_name);
        $criteria->compare('dme_service', $this->dme_service);
        $criteria->compare('emr_id', $this->emr_id);
        $criteria->compare('practice_size', $this->practice_size);
        $criteria->compare('sole_proprietor_provider_id', $this->sole_proprietor_provider_id);
        $criteria->compare('twilio_number', $this->twilio_number, true);
        $criteria->compare('twilio_status', $this->twilio_status);
        $criteria->compare('reviewhub_sharing', $this->reviewhub_sharing, true);
        $criteria->compare('review_request_auto_daily_limit', $this->review_request_auto_daily_limit, true);
        $criteria->compare('score_missing_data', $this->score_missing_data, true);
        $criteria->compare('uberall_location_id', $this->uberall_location_id, true);
        $criteria->compare('yext_special_offer', $this->yext_special_offer, true);
        $criteria->compare('reward_email', $this->reward_email, true);
        $criteria->compare('email_prefix', $this->email_prefix, true);
        $criteria->compare('review_request_auto_subject', $this->review_request_auto_subject, true);
        $criteria->compare('review_request_email_subject', $this->review_request_email_subject, true);
        $criteria->compare('review_request_service_text', $this->review_request_service_text, true);
        $criteria->compare('review_request_service_link', $this->review_request_service_link, true);
        $criteria->compare('review_request_email_title', $this->review_request_email_title, true);
        $criteria->compare('review_request_email_body', $this->review_request_email_body, true);
        $criteria->compare('review_request_sms_body', $this->review_request_sms_body, true);
        $criteria->compare('review_request_auto_body', $this->review_request_auto_body, true);
        $criteria->compare('google_review_email_title', $this->google_review_email_title, true);
        $criteria->compare('google_review_email_body', $this->google_review_email_body, true);
        $criteria->compare('google_review_sms_body', $this->google_review_sms_body, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('yelp_review_email_title', $this->yelp_review_email_title, true);
        $criteria->compare('yelp_review_email_body', $this->yelp_review_email_body, true);
        $criteria->compare('yelp_review_sms_body', $this->yelp_review_sms_body, true);
        $criteria->compare('close_status', $this->close_status, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
